<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;regex-1.5.4&#x2F;src&#x2F;re_set.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>re_set.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../regex/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
</pre><pre class="rust"><code><span class="macro">macro_rules!</span> <span class="ident">define_set</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">builder_mod</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">text_ty</span>:<span class="ident">ty</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">as_bytes</span>:<span class="ident">expr</span>,
     $(<span class="attribute">#[<span class="macro-nonterminal">$</span><span class="macro-nonterminal">doc_regexset_example</span>:<span class="ident">meta</span>]</span>)<span class="op">*</span> ) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="kw">pub</span> <span class="kw">mod</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span> {
            <span class="kw">use</span> <span class="ident">std::fmt</span>;
            <span class="kw">use</span> <span class="ident">std::iter</span>;
            <span class="kw">use</span> <span class="ident">std::slice</span>;
            <span class="kw">use</span> <span class="ident">std::vec</span>;

            <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::error::Error</span>;
            <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::exec::Exec</span>;
            <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::re_builder</span>::<span class="macro-nonterminal">$</span><span class="macro-nonterminal">builder_mod::RegexSetBuilder</span>;
            <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::re_trait::RegularExpression</span>;

<span class="doccomment">/// Match multiple (possibly overlapping) regular expressions in a single scan.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A regex set corresponds to the union of two or more regular expressions.</span>
<span class="doccomment">/// That is, a regex set will match text where at least one of its</span>
<span class="doccomment">/// constituent regular expressions matches. A regex set as its formulated here</span>
<span class="doccomment">/// provides a touch more power: it will also report *which* regular</span>
<span class="doccomment">/// expressions in the set match. Indeed, this is the key difference between</span>
<span class="doccomment">/// regex sets and a single `Regex` with many alternates, since only one</span>
<span class="doccomment">/// alternate can match at a time.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For example, consider regular expressions to match email addresses and</span>
<span class="doccomment">/// domains: `[a-z]+@[a-z]+\.(com|org|net)` and `[a-z]+\.(com|org|net)`. If a</span>
<span class="doccomment">/// regex set is constructed from those regexes, then searching the text</span>
<span class="doccomment">/// `foo@example.com` will report both regexes as matching. Of course, one</span>
<span class="doccomment">/// could accomplish this by compiling each regex on its own and doing two</span>
<span class="doccomment">/// searches over the text. The key advantage of using a regex set is that it</span>
<span class="doccomment">/// will report the matching regexes using a *single pass through the text*.</span>
<span class="doccomment">/// If one has hundreds or thousands of regexes to match repeatedly (like a URL</span>
<span class="doccomment">/// router for a complex web application or a user agent matcher), then a regex</span>
<span class="doccomment">/// set can realize huge performance gains.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This shows how the above two regexes (for matching email addresses and</span>
<span class="doccomment">/// domains) might work:</span>
<span class="doccomment">///</span>
$(<span class="attribute">#[<span class="macro-nonterminal">$</span><span class="macro-nonterminal">doc_regexset_example</span>]</span>)<span class="op">*</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that it would be possible to adapt the above example to using `Regex`</span>
<span class="doccomment">/// with an expression like:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```text</span>
<span class="doccomment">/// (?P&lt;email&gt;[a-z]+@(?P&lt;email_domain&gt;[a-z]+[.](com|org|net)))|(?P&lt;domain&gt;[a-z]+[.](com|org|net))</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// After a match, one could then inspect the capture groups to figure out</span>
<span class="doccomment">/// which alternates matched. The problem is that it is hard to make this</span>
<span class="doccomment">/// approach scale when there are many regexes since the overlap between each</span>
<span class="doccomment">/// alternate isn&#39;t always obvious to reason about.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Limitations</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Regex sets are limited to answering the following two questions:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// 1. Does any regex in the set match?</span>
<span class="doccomment">/// 2. If so, which regexes in the set match?</span>
<span class="doccomment">///</span>
<span class="doccomment">/// As with the main `Regex` type, it is cheaper to ask (1) instead of (2)</span>
<span class="doccomment">/// since the matching engines can stop after the first match is found.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Other features like finding the location of successive matches or their</span>
<span class="doccomment">/// sub-captures aren&#39;t supported. If you need this functionality, the</span>
<span class="doccomment">/// recommended approach is to compile each regex in the set independently and</span>
<span class="doccomment">/// selectively match them based on which regexes in the set matched.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Performance</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A `RegexSet` has the same performance characteristics as `Regex`. Namely,</span>
<span class="doccomment">/// search takes `O(mn)` time, where `m` is proportional to the size of the</span>
<span class="doccomment">/// regex set and `n` is proportional to the length of the search text.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RegexSet</span>(<span class="ident">Exec</span>);

<span class="kw">impl</span> <span class="ident">RegexSet</span> {
    <span class="doccomment">/// Create a new regex set with the given regular expressions.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This takes an iterator of `S`, where `S` is something that can produce</span>
    <span class="doccomment">/// a `&amp;str`. If any of the strings in the iterator are not valid regular</span>
    <span class="doccomment">/// expressions, then an error is returned.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Create a new regex set from an iterator of strings:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use regex::RegexSet;</span>
    <span class="doccomment">/// let set = RegexSet::new(&amp;[r&quot;\w+&quot;, r&quot;\d+&quot;]).unwrap();</span>
    <span class="doccomment">/// assert!(set.is_match(&quot;foo&quot;));</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span><span class="op">&lt;</span><span class="ident">I</span>, <span class="ident">S</span><span class="op">&gt;</span>(<span class="ident">exprs</span>: <span class="ident">I</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">RegexSet</span>, <span class="ident">Error</span><span class="op">&gt;</span>
            <span class="kw">where</span> <span class="ident">S</span>: <span class="ident">AsRef</span><span class="op">&lt;</span><span class="ident">str</span><span class="op">&gt;</span>, <span class="ident">I</span>: <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span><span class="op">=</span><span class="ident">S</span><span class="op">&gt;</span> {
        <span class="ident">RegexSetBuilder::new</span>(<span class="ident">exprs</span>).<span class="ident">build</span>()
    }

    <span class="doccomment">/// Create a new empty regex set.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use regex::RegexSet;</span>
    <span class="doccomment">/// let set = RegexSet::empty();</span>
    <span class="doccomment">/// assert!(set.is_empty());</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">empty</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">RegexSet</span> {
        <span class="ident">RegexSetBuilder::new</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;&quot;</span>; <span class="number">0</span>]).<span class="ident">build</span>().<span class="ident">unwrap</span>()
    }

    <span class="doccomment">/// Returns true if and only if one of the regexes in this set matches</span>
    <span class="doccomment">/// the text given.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method should be preferred if you only need to test whether any</span>
    <span class="doccomment">/// of the regexes in the set should match, but don&#39;t care about *which*</span>
    <span class="doccomment">/// regexes matched. This is because the underlying matching engine will</span>
    <span class="doccomment">/// quit immediately after seeing the first match instead of continuing to</span>
    <span class="doccomment">/// find all matches.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that as with searches using `Regex`, the expression is unanchored</span>
    <span class="doccomment">/// by default. That is, if the regex does not start with `^` or `\A`, or</span>
    <span class="doccomment">/// end with `$` or `\z`, then it is permitted to match anywhere in the</span>
    <span class="doccomment">/// text.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Tests whether a set matches some text:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use regex::RegexSet;</span>
    <span class="doccomment">/// let set = RegexSet::new(&amp;[r&quot;\w+&quot;, r&quot;\d+&quot;]).unwrap();</span>
    <span class="doccomment">/// assert!(set.is_match(&quot;foo&quot;));</span>
    <span class="doccomment">/// assert!(!set.is_match(&quot;☃&quot;));</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_match</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">text</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">text_ty</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">is_match_at</span>(<span class="ident">text</span>, <span class="number">0</span>)
    }

    <span class="doccomment">/// Returns the same as is_match, but starts the search at the given</span>
    <span class="doccomment">/// offset.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The significance of the starting point is that it takes the surrounding</span>
    <span class="doccomment">/// context into consideration. For example, the `\A` anchor can only</span>
    <span class="doccomment">/// match when `start == 0`.</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_match_at</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">text</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">text_ty</span>, <span class="ident">start</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">searcher</span>().<span class="ident">is_match_at</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">as_bytes</span>(<span class="ident">text</span>), <span class="ident">start</span>)
    }

    <span class="doccomment">/// Returns the set of regular expressions that match in the given text.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The set returned contains the index of each regular expression that</span>
    <span class="doccomment">/// matches in the given text. The index is in correspondence with the</span>
    <span class="doccomment">/// order of regular expressions given to `RegexSet`&#39;s constructor.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The set can also be used to iterate over the matched indices.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that as with searches using `Regex`, the expression is unanchored</span>
    <span class="doccomment">/// by default. That is, if the regex does not start with `^` or `\A`, or</span>
    <span class="doccomment">/// end with `$` or `\z`, then it is permitted to match anywhere in the</span>
    <span class="doccomment">/// text.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Tests which regular expressions match the given text:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use regex::RegexSet;</span>
    <span class="doccomment">/// let set = RegexSet::new(&amp;[</span>
    <span class="doccomment">///     r&quot;\w+&quot;,</span>
    <span class="doccomment">///     r&quot;\d+&quot;,</span>
    <span class="doccomment">///     r&quot;\pL+&quot;,</span>
    <span class="doccomment">///     r&quot;foo&quot;,</span>
    <span class="doccomment">///     r&quot;bar&quot;,</span>
    <span class="doccomment">///     r&quot;barfoo&quot;,</span>
    <span class="doccomment">///     r&quot;foobar&quot;,</span>
    <span class="doccomment">/// ]).unwrap();</span>
    <span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(&quot;foobar&quot;).into_iter().collect();</span>
    <span class="doccomment">/// assert_eq!(matches, vec![0, 2, 3, 4, 6]);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // You can also test whether a particular regex matched:</span>
    <span class="doccomment">/// let matches = set.matches(&quot;foobar&quot;);</span>
    <span class="doccomment">/// assert!(!matches.matched(5));</span>
    <span class="doccomment">/// assert!(matches.matched(6));</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matches</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">text</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">text_ty</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">SetMatches</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">matches</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="bool-val">false</span>; <span class="self">self</span>.<span class="number">0</span>.<span class="ident">regex_strings</span>().<span class="ident">len</span>()];
        <span class="kw">let</span> <span class="ident">any</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">read_matches_at</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">matches</span>, <span class="ident">text</span>, <span class="number">0</span>);
        <span class="ident">SetMatches</span> {
            <span class="ident">matched_any</span>: <span class="ident">any</span>,
            <span class="ident">matches</span>: <span class="ident">matches</span>,
        }
    }

    <span class="doccomment">/// Returns the same as matches, but starts the search at the given</span>
    <span class="doccomment">/// offset and stores the matches into the slice given.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The significance of the starting point is that it takes the surrounding</span>
    <span class="doccomment">/// context into consideration. For example, the `\A` anchor can only</span>
    <span class="doccomment">/// match when `start == 0`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// `matches` must have a length that is at least the number of regexes</span>
    <span class="doccomment">/// in this set.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This method returns true if and only if at least one member of</span>
    <span class="doccomment">/// `matches` is true after executing the set against `text`.</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">read_matches_at</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">matches</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">bool</span>],
        <span class="ident">text</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">text_ty</span>,
        <span class="ident">start</span>: <span class="ident">usize</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">searcher</span>().<span class="ident">many_matches_at</span>(<span class="ident">matches</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">as_bytes</span>(<span class="ident">text</span>), <span class="ident">start</span>)
    }

    <span class="doccomment">/// Returns the total number of regular expressions in this set.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">regex_strings</span>().<span class="ident">len</span>()
    }

    <span class="doccomment">/// Returns `true` if this set contains no regular expressions.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_empty</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">regex_strings</span>().<span class="ident">is_empty</span>()
    }

    <span class="doccomment">/// Returns the patterns that this set will match on.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function can be used to determine the pattern for a match. The</span>
    <span class="doccomment">/// slice returned has exactly as many patterns givens to this regex set,</span>
    <span class="doccomment">/// and the order of the slice is the same as the order of the patterns</span>
    <span class="doccomment">/// provided to the set.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use regex::RegexSet;</span>
    <span class="doccomment">/// let set = RegexSet::new(&amp;[</span>
    <span class="doccomment">///     r&quot;\w+&quot;,</span>
    <span class="doccomment">///     r&quot;\d+&quot;,</span>
    <span class="doccomment">///     r&quot;\pL+&quot;,</span>
    <span class="doccomment">///     r&quot;foo&quot;,</span>
    <span class="doccomment">///     r&quot;bar&quot;,</span>
    <span class="doccomment">///     r&quot;barfoo&quot;,</span>
    <span class="doccomment">///     r&quot;foobar&quot;,</span>
    <span class="doccomment">/// ]).unwrap();</span>
    <span class="doccomment">/// let matches: Vec&lt;_&gt; = set</span>
    <span class="doccomment">///     .matches(&quot;foobar&quot;)</span>
    <span class="doccomment">///     .into_iter()</span>
    <span class="doccomment">///     .map(|match_idx| &amp;set.patterns()[match_idx])</span>
    <span class="doccomment">///     .collect();</span>
    <span class="doccomment">/// assert_eq!(matches, vec![r&quot;\w+&quot;, r&quot;\pL+&quot;, r&quot;foo&quot;, r&quot;bar&quot;, r&quot;foobar&quot;]);</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">patterns</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">String</span>] {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">regex_strings</span>()
    }
}

<span class="doccomment">/// A set of matches returned by a regex set.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SetMatches</span> {
    <span class="ident">matched_any</span>: <span class="ident">bool</span>,
    <span class="ident">matches</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">bool</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">SetMatches</span> {
    <span class="doccomment">/// Whether this set contains any matches.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matched_any</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">matched_any</span>
    }

    <span class="doccomment">/// Whether the regex at the given index matched.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The index for a regex is determined by its insertion order upon the</span>
    <span class="doccomment">/// initial construction of a `RegexSet`, starting at `0`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Panics</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If `regex_index` is greater than or equal to `self.len()`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matched</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">regex_index</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">matches</span>[<span class="ident">regex_index</span>]
    }

    <span class="doccomment">/// The total number of regexes in the set that created these matches.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">matches</span>.<span class="ident">len</span>()
    }

    <span class="doccomment">/// Returns an iterator over indexes in the regex that matched.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This will always produces matches in ascending order of index, where</span>
    <span class="doccomment">/// the index corresponds to the index of the regex that matched with</span>
    <span class="doccomment">/// respect to its position when initially building the set.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">SetMatchesIter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="ident">SetMatchesIter</span>((<span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="self">self</span>.<span class="ident">matches</span>).<span class="ident">into_iter</span>().<span class="ident">enumerate</span>())
    }
}

<span class="kw">impl</span> <span class="ident">IntoIterator</span> <span class="kw">for</span> <span class="ident">SetMatches</span> {
    <span class="kw">type</span> <span class="ident">IntoIter</span> <span class="op">=</span> <span class="ident">SetMatchesIntoIter</span>;
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="kw">fn</span> <span class="ident">into_iter</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident"><span class="self">Self</span>::IntoIter</span> {
        <span class="ident">SetMatchesIntoIter</span>(<span class="self">self</span>.<span class="ident">matches</span>.<span class="ident">into_iter</span>().<span class="ident">enumerate</span>())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">IntoIterator</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">SetMatches</span> {
    <span class="kw">type</span> <span class="ident">IntoIter</span> <span class="op">=</span> <span class="ident">SetMatchesIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>;
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="kw">fn</span> <span class="ident">into_iter</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident"><span class="self">Self</span>::IntoIter</span> {
        <span class="self">self</span>.<span class="ident">iter</span>()
    }
}

<span class="doccomment">/// An owned iterator over the set of matches from a regex set.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This will always produces matches in ascending order of index, where the</span>
<span class="doccomment">/// index corresponds to the index of the regex that matched with respect to</span>
<span class="doccomment">/// its position when initially building the set.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SetMatchesIntoIter</span>(<span class="ident">iter::Enumerate</span><span class="op">&lt;</span><span class="ident">vec::IntoIter</span><span class="op">&lt;</span><span class="ident">bool</span><span class="op">&gt;</span><span class="op">&gt;</span>);

<span class="kw">impl</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">SetMatchesIntoIter</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">loop</span> {
            <span class="kw">match</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">next</span>() {
                <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">None</span>,
                <span class="prelude-val">Some</span>((<span class="kw">_</span>, <span class="bool-val">false</span>)) <span class="op">=</span><span class="op">&gt;</span> {}
                <span class="prelude-val">Some</span>((<span class="ident">i</span>, <span class="bool-val">true</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>),
            }
        }
    }

    <span class="kw">fn</span> <span class="ident">size_hint</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">usize</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">size_hint</span>()
    }
}

<span class="kw">impl</span> <span class="ident">DoubleEndedIterator</span> <span class="kw">for</span> <span class="ident">SetMatchesIntoIter</span> {
    <span class="kw">fn</span> <span class="ident">next_back</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">loop</span> {
            <span class="kw">match</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">next_back</span>() {
                <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">None</span>,
                <span class="prelude-val">Some</span>((<span class="kw">_</span>, <span class="bool-val">false</span>)) <span class="op">=</span><span class="op">&gt;</span> {}
                <span class="prelude-val">Some</span>((<span class="ident">i</span>, <span class="bool-val">true</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>),
            }
        }
    }
}

<span class="kw">impl</span> <span class="ident">iter::FusedIterator</span> <span class="kw">for</span> <span class="ident">SetMatchesIntoIter</span> {}

<span class="doccomment">/// A borrowed iterator over the set of matches from a regex set.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The lifetime `&#39;a` refers to the lifetime of a `SetMatches` value.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This will always produces matches in ascending order of index, where the</span>
<span class="doccomment">/// index corresponds to the index of the regex that matched with respect to</span>
<span class="doccomment">/// its position when initially building the set.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SetMatchesIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="ident">iter::Enumerate</span><span class="op">&lt;</span><span class="ident">slice::Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">bool</span><span class="op">&gt;</span><span class="op">&gt;</span>);

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">SetMatchesIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">loop</span> {
            <span class="kw">match</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">next</span>() {
                <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">None</span>,
                <span class="prelude-val">Some</span>((<span class="kw">_</span>, <span class="kw-2">&amp;</span><span class="bool-val">false</span>)) <span class="op">=</span><span class="op">&gt;</span> {}
                <span class="prelude-val">Some</span>((<span class="ident">i</span>, <span class="kw-2">&amp;</span><span class="bool-val">true</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>),
            }
        }
    }

    <span class="kw">fn</span> <span class="ident">size_hint</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">usize</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">size_hint</span>()
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">DoubleEndedIterator</span> <span class="kw">for</span> <span class="ident">SetMatchesIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">next_back</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">loop</span> {
            <span class="kw">match</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">next_back</span>() {
                <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">None</span>,
                <span class="prelude-val">Some</span>((<span class="kw">_</span>, <span class="kw-2">&amp;</span><span class="bool-val">false</span>)) <span class="op">=</span><span class="op">&gt;</span> {}
                <span class="prelude-val">Some</span>((<span class="ident">i</span>, <span class="kw-2">&amp;</span><span class="bool-val">true</span>)) <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>),
            }
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">iter::FusedIterator</span> <span class="kw">for</span> <span class="ident">SetMatchesIter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {}

<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">impl</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">Exec</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">RegexSet</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">exec</span>: <span class="ident">Exec</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">RegexSet</span>(<span class="ident">exec</span>)
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">RegexSet</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;RegexSet({:?})&quot;</span>, <span class="self">self</span>.<span class="number">0</span>.<span class="ident">regex_strings</span>())
    }
}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span> <span class="kw">fn</span> <span class="ident">as_bytes_str</span>(<span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] { <span class="ident">text</span>.<span class="ident">as_bytes</span>() }
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span> <span class="kw">fn</span> <span class="ident">as_bytes_bytes</span>(<span class="ident">text</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] { <span class="ident">text</span> }
        }
    }
}

<span class="macro">define_set!</span> {
    <span class="ident">unicode</span>,
    <span class="ident">set_unicode</span>,
    <span class="kw-2">&amp;</span><span class="ident">str</span>,
    <span class="ident">as_bytes_str</span>,
<span class="doccomment">/// ```rust</span>
<span class="doccomment">/// # use regex::RegexSet;</span>
<span class="doccomment">/// let set = RegexSet::new(&amp;[</span>
<span class="doccomment">///     r&quot;[a-z]+@[a-z]+\.(com|org|net)&quot;,</span>
<span class="doccomment">///     r&quot;[a-z]+\.(com|org|net)&quot;,</span>
<span class="doccomment">/// ]).unwrap();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Ask whether any regexes in the set match.</span>
<span class="doccomment">/// assert!(set.is_match(&quot;foo@example.com&quot;));</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Identify which regexes in the set match.</span>
<span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(&quot;foo@example.com&quot;).into_iter().collect();</span>
<span class="doccomment">/// assert_eq!(vec![0, 1], matches);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Try again, but with text that only matches one of the regexes.</span>
<span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(&quot;example.com&quot;).into_iter().collect();</span>
<span class="doccomment">/// assert_eq!(vec![1], matches);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Try again, but with text that doesn&#39;t match any regex in the set.</span>
<span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(&quot;example&quot;).into_iter().collect();</span>
<span class="doccomment">/// assert!(matches.is_empty());</span>
<span class="doccomment">/// ```</span>
}

<span class="macro">define_set!</span> {
    <span class="ident">bytes</span>,
    <span class="ident">set_bytes</span>,
    <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">as_bytes_bytes</span>,
<span class="doccomment">/// ```rust</span>
<span class="doccomment">/// # use regex::bytes::RegexSet;</span>
<span class="doccomment">/// let set = RegexSet::new(&amp;[</span>
<span class="doccomment">///     r&quot;[a-z]+@[a-z]+\.(com|org|net)&quot;,</span>
<span class="doccomment">///     r&quot;[a-z]+\.(com|org|net)&quot;,</span>
<span class="doccomment">/// ]).unwrap();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Ask whether any regexes in the set match.</span>
<span class="doccomment">/// assert!(set.is_match(b&quot;foo@example.com&quot;));</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Identify which regexes in the set match.</span>
<span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(b&quot;foo@example.com&quot;).into_iter().collect();</span>
<span class="doccomment">/// assert_eq!(vec![0, 1], matches);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Try again, but with text that only matches one of the regexes.</span>
<span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(b&quot;example.com&quot;).into_iter().collect();</span>
<span class="doccomment">/// assert_eq!(vec![1], matches);</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // Try again, but with text that doesn&#39;t match any regex in the set.</span>
<span class="doccomment">/// let matches: Vec&lt;_&gt; = set.matches(b&quot;example&quot;).into_iter().collect();</span>
<span class="doccomment">/// assert!(matches.is_empty());</span>
<span class="doccomment">/// ```</span>
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="regex" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>